<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-profils', params: { profil: 'admin' } }" link-text="Annuler">
      <h1 class="has-text-weight-bold is-size-3">création d'un profil</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-profil
        :profil="profil"
        :roles="roles"
        :selected-roles="selectedRoles"
        :types-organismes="typesOrganismes"
      />
      <div class="columns is-centered">
        <b-button type="is-primary has-text-weight-semibold" native-type="submit">
          Créer le profil
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormProfil from '~/components/dashboard/profil/champs-form-profil';
import { newProfil, getData } from '~/components/mixins/profilMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormProfil,
  },
  asyncData(context) {
    const profil = newProfil();
    return getData(context, profil);
  },
  methods: {
    async submit() {
      try {
        this.roles.forEach((role) => {
          if (this.selectedRoles[role]) this.profil.roles.push(role);
        });
        await this.$api.profils.post(this.profil);
        this.$router.push({ name: 'profil-dashboard-profils', params: { profil: 'admin' } });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss"></style>
